Unit encoding;

interface

Function a2k_encode(const s: AnsiString): AnsiString;
Function k2a_encode(const s: AnsiString): AnsiString;

implementation

Type
  ttable	= Array[#0..#255] of Char;

Var
  a2k_table, k2a_table	: ttable;

Procedure GetTable(const fn: String; var tb: ttable);
var f: File of ttable;
begin
  Assign(f, fn); Reset(f);
  Read(f, tb); Close(f);
end;

Function encode(const s: AnsiString; const t: ttable): AnsiString;
var n: LongInt;
begin
  SetLength(encode, Length(s));
  For n:=1 to Length(s) do encode[n]:=t[s[n]];
end;

Function a2k_encode(const s: AnsiString): AnsiString;
begin
  a2k_encode:=encode(s, a2k_table);
end;

Function k2a_encode(const s: AnsiString): AnsiString;
begin
  k2a_encode:=encode(s, k2a_table);
end;

begin
{$ifdef UNIX}
  GetTable('/ms-dos/BaseTools:/DECODER/ALT2KOI.TBL', a2k_table);
  GetTable('/ms-dos/BaseTools:/DECODER/KOI2ALT.TBL', k2a_table);
{$endif}
{$ifdef GO32V2}
  GetTable('d:/DECODER/ALT2KOI.TBL', a2k_table);
  GetTable('d:/DECODER/KOI2ALT.TBL', k2a_table);
{$endif}
end.