uses lredit, lrwvio, lrwvfm, lrwvvw, lrmixr, Inferno, Alf, Mikky, X, X11, XLib, XUtil, Ini, VGAColors;

type
  tWinState	= Record
    Lab		: PChar;
    State	: Boolean;
    pWnd	: PWindow;
    msEvent	: RngMouseArea;
  end;

const
  WinStates	: array[1..8] of tWinState = (
    (Lab: '';	State: True;  pWnd: @wvvwWndMain),
    (Lab: '';	State: False; pWnd: @wvvwWndStat),
    (Lab: 'OSS';	State: True;  pWnd: @mixrWnd),
    (Lab: '';	State: False; pWnd: @editWndRange),
    (Lab: '.';	State: False; pWnd: @editWndParam),
    (Lab: '.';	State: False; pWnd: @editWndPlay),
    (Lab: '';	State: False; pWnd: @editWndLoop),
    (Lab: '';	State: False; pWnd: @editWndRec)
  );

  WndX		: LongInt = 0;
  WndY		: LongInt = 750;
  WndW		= 700;
  WndH		= 30;
  Border	= 6;
  ButStep	= (WndW - Border) div (High(WinStates) - Low(WinStates) + 1);
  bC		= 0;
  fC		= 3;

var
  OldFullingTime	: TFullingTime;
  OldExitProc		: Pointer;
  Event			: TXEvent;
  Wnd			: TWindow;


procedure intChangeState(var ws);
begin with tWinState(ws) do if pWnd^ <> 0 then begin //    -     
  State := not State;
  if State then begin
    XMapWindow(prDisplay, pWnd^);
    SetMouseArea(msEvent, bC, fC, Lab);
  end else begin
    XUnMapWindow(prDisplay, pWnd^);
    SetMouseArea(msEvent, fC, bC, Lab);
  end;
end end;


procedure BG(var Event: TXEvent; const BlockEn: Boolean);
var i: LongInt;
begin
  OldFullingTime(Event, BlockEn);
  case Event.EventType of

  DeleteNotify: begin
    if CurrentWindow = Wnd then Halt;
    For i := Low(WinStates) to High(WinStates) do with WinStates[i] do
      if CurrentWindow = pWnd^ then begin
        intChangeState(WinStates[i]);
	DrawButton(msEvent);
      end;
  end;

  KeyPress: begin
    i := KeyInResult;
    dec(i, ord('1') - Low(WinStates));
    if (Low(WinStates) <= i) and (i <= High(WinStates)) then intChangeState(WinStates[i]);
  end;

  end;
end;


procedure intCreateWindow;
var i: LongInt;
begin
  NewRootWindow(WndX, WndY, WndW, WndH, 'Lera', Wnd);
  For i := Low(WinStates) to High(WinStates) do with WinStates[i] do begin
    NewMouseArea(Wnd, msEvent);
    SetMouseRoutines(msEvent, Nil, WinStates[i], @intChangeState, @intChangeState, @intChangeState);
    SetMouseArea(msEvent, (i - Low(WinStates)) * ButStep + Border, Border, ButStep - Border, WndH - Border * 2);
    intChangeState(WinStates[i]);
  end;
  editIndWnd := Wnd;
  editIndWndW := WndW; editIndWndH := WndH;
  SetVGAPalette(editIndWnd, editColors);
end;


procedure intGetStates;
var i: LongInt;
begin
  IniOpen('Lera');
  For i := Low(WinStates) to High(WinStates) do With WinStates[i] do begin
    IniGet('Win ' + ValToStrG(i), State);
  end;
  IniGet('X', WndX);
  IniGet('Y', WndY);
  IniClose;
end;


procedure intPutStates;
var i: LongInt;
begin
  IniOpen('Lera');
  For i := Low(WinStates) to High(WinStates) do IniPut('Win ' + ValToStrG(i), not WinStates[i].State);
  IniClose;
end;


procedure intExitProc;
begin ExitProc := OldExitProc; intPutStates end;


begin
  WriteLn('LERA   Version 3.0  [for X Window System (TM) & OSS]  i386');
  WriteLn('Copyright  (c)  2001, 2002, 2004, 2005   Ravodin & ...');
  WriteLn(' 09.09.2005');
  
  OldFullingTime := FullingTime;	FullingTime := @BG;
  OldExitProc := ExitProc;		ExitProc := @intExitProc;

  intGetStates;
  intCreateWindow;

  repeat FullingTime(Event, True); until KeyInResult = XK_Escape;
end.
