// LERA: Editor
unit lredit;

{ define SelfTune}

interface
uses lrwvvw, lrwvfm, lrmixr, lrwvio, lerahd, Mikky, Inferno, Alf, Ini, X, X11, XLib, XUtil, VGAColors;

var
  editIndWnd			: TWindow;	//     
  editColors			: TColors;	// ,    
  editIndWndW, editIndWndH	: LongInt;	//   

  editWndRange, editWndParam,
  editWndPlay, editWndLoop,
  editWndRec			: TWindow;

implementation
const
  BsFlNm	: String = 'noname0.wav';
  ToFlNm	: String = 'noname1.wav';
  InFlNm	: String = 'noname2.wav';

  PropPos	: Boolean = True; //     
  FilesNoLocked	: Boolean = True; //    -     , , 

  WndRangeX	: LongInt = 000;
  WndRangeY	: LongInt = 349;
  WndRangeW	= 700;
  WndRangeH	= 270;

  WndParamX	: LongInt = 000;
  WndParamY	: LongInt = 605;
  WndParamW	= 580;
  WndParamH	= 177;

  WndPlayX	: LongInt = 588;
  WndPlayY	: LongInt = 605;
  WndPlayW	= 400;
  WndPlayH	= 150;

  WndLoopX	: LongInt = 279;
  WndLoopY	: LongInt = 237;
  WndLoopW	= 340;
  WndLoopH	= 106;

  WndRecX	: LongInt = 457;
  WndRecY	: LongInt = 236;
  WndRecW	= 490;
  WndRecH	= 160;

type
  //   -  
  tInfoRange	= (inrFr1, inrFr2, inrIns, inrAll, inrLnk);
  tInfoParam	= (inpFr1, inpAll);

  //       
  tAction	= (
    acEditStr,		// 
    acEditWord,		// Word
    acXorWord,		// Word := Word xor 3
    acEditFilter,	//   <-> 
    acEditACL,		//   
    acMrLink,		//    
    acMrSel,		//   
    acStart,		//   
    acRInfoSel,		// Range-window 
    acPInfoSel,		// Param-window 
    acFreeSel,		//  
    acSwBool,		// ""
    acNone		//  (  )
  );

  tMarkers	= (mrZr, mrT1, mrT2, mrCr, mrM1, mrM2, mrLn);

  //  
  tItems	= 0..49;

const
  //  ,  ParamEdit
  NewRate	: Word = 2;
  NewChanels	: Word = 2;
  NewFreq	: Word = 44100;
  NewFilterIndex: wvtFilterIndex = wvflNothing;

  //  ,  Rec
  RecRate	: Word = 2;
  RecChanels	: Word = 2;
  RecFreq	: Word = 44100;

  zero		: Longint = 0;

  //       
  Markers	: array[0..3] of tMarkers = (mrZr, mrT1, mrM2, mrLn);

  //  
  Ranges	: array[tMarkers] of ^Cardinal = (@zero, @wvvwT1, @wvvwT2, @wvvwPos, @wvvwM1, @wvvwM2, @wvRlen);

  CurMarker	: 0..3 = 0;
  InfoParam	: tInfoParam = inpAll;
  InfoRange	: tInfoRange = inrAll;
  nMarkers	= ord(High(tMarkers))-ord(Low(tMarkers))+1;

  FontLabel	: String = '-*-*-medium-r-*-*-*-*-*-*-*-*-koi8-*';

var
  OldFullingTime				: TFullingTime;
  OldExitproc					: Pointer;
  ColRange, ColParam, ColPlay, ColLoop, ColRec	: TColors;


//    
procedure intTestFiles(const iByte: Byte);
begin
  if iByte and 1 <> 0 then begin
    if BsFlNm = '' then BsFlNm := '*';
    if wvfmNewFile(BsFlNm, InFlNm) then InFlNm := '*';
    NewRate := wvRrate; NewChanels := wvRchanels; NewFreq := wvRfreq;
    wvWrate := RecRate; wvWchanels := RecChanels; wvWfreq := RecFreq;
    wvvwNewFile(BsFlNm);
    mixrNewFile;
  end;
  if iByte and 2 <> 0 then begin
    if wvfmNewFile(BsFlNm, InFlNm) then InFlNm := '*';
  end;
//  if iByte and 4 <> 0 then begin
//  end;
  if (ToFlNm = '') or (ToFlNm = BsFlNm) or (ToFlNm = InFlNm) then ToFlNm := '/dev/null';
end;


//  
procedure Ind(ready: Single);
var GC: TGC;
begin
  GC := XCreateGC(prDisplay, editIndWnd, 0, Nil);
  XSetForeGround(prDisplay, GC, editColors[12]);
  XFillRectangle(prDisplay, editIndWnd, GC, 0, 0, Round(editIndWndW * ready), editIndWndH {Round(editIndWndH * ready)} );
  XFreeGC(prDisplay, GC);
  XFlush(prDisplay);
end;


//     
procedure blrOper(const iByte: Byte);
begin
  case iByte of
    0: begin Markers[0] := mrT1; Markers[1] := mrM2; Markers[2] := mrLn; Markers[3] := mrLn end;
    1: begin Markers[0] := mrZr; Markers[1] := mrT2; Markers[2] := mrM1; Markers[3] := mrLn end;
    2: begin Markers[0] := mrZr; Markers[1] := mrCr; Markers[2] := mrCr; Markers[3] := mrLn end;
  end;
  if (iByte <> 2) and FilesNoLocked then begin
    InFlNm := ''; intTestFiles(2);
  end;
end;


//    / ( "GO !")
procedure blGo(const iByte: Byte);
begin
  if (wvRlen <> 0) and FilesNoLocked then begin
    case iByte of
      0: CopyToFile(InFlNm, ToFlNm, Ranges[Markers[0]]^, Ranges[Markers[1]]^, Ranges[Markers[2]]^, Ranges[Markers[3]]^, @Ind);
      2: ChangeFormat(ToFlNm,      0, wvRlen, NewRate, NewChanels, NewFreq, NewFilterIndex, @Ind);
      1: ChangeFormat(ToFlNm, wvvwT1, wvvwM2, NewRate, NewChanels, NewFreq, NewFilterIndex, @Ind);
    end;
    XClearWindow(prDisplay, editIndWnd);
  end;
end;


const
  btR0			= 13;
  btR1			= btR0 + 1;
  btR2			= btR0 + 2;
  btR3			= btR0 + 3;
  
  Items: Array[tItems] of Record
    Wnd			: PWindow;			//    
    pCol		: ^TColors;			//    
    x, y		: LongInt;			// 
    bC, fC		: Byte;				// 
    Lab, fLab		: AnsiString;			//    ,   
    Action		: tAction;			//  
    msEvent		: RngMouseArea;			//     
    iByte		: Byte;				//  
    case Byte of
     1: (pRoute		: Procedure(const iByte: Byte));//      
     2: (iMarker	: tMarkers);			//    
     3: (pTStr		: ^String);
     4: (pWord		: ^Word);
     5: (FilterIndex	: ^wvtFilterIndex);
     6: (ACL		: ^iotAutoCtrlLevel)
  end = (
    //  
    (Wnd: @editWndRange; pCol: @ColRange; x: 170; y: 015; bC: 0; fC: 14; Lab: '';		fLab: ''; Action: acStart;	msEvent: 0; iByte: 0; pRoute: @blrOper),
    (Wnd: @editWndRange; pCol: @ColRange; x: 360; y: 015; bC: 0; fC: 14; Lab: '';		fLab: ''; Action: acStart;	msEvent: 0; iByte: 1; pRoute: @blrOper),
    (Wnd: @editWndRange; pCol: @ColRange; x: 530; y: 015; bC: 0; fC: 14; Lab: '';		fLab: ''; Action: acStart;	msEvent: 0; iByte: 2; pRoute: @blrOper), 

    (Wnd: @editWndRange; pCol: @ColRange; x: 300; y: 045; bC: 0; fC: 10; Lab: ' ';		fLab: ''; Action: acEditStr;	msEvent: 0; iByte: 1; pTStr: @BsFlNm), 
    (Wnd: @editWndRange; pCol: @ColRange; x: 080; y: 045; bC: 0; fC: 12; Lab: '';		fLab: ''; Action: acSwBool),
    (Wnd: @editWndRange; pCol: @ColRange; x:   0; y: 080; bC: 0; fC: 15; Lab: 'Top';			fLab: ''; Action: acMrLink;	msEvent: 0; iByte: 0; iMarker: mrZr), 
    (Wnd: @editWndRange; pCol: @ColRange; x:   0; y: 080; bC: 0; fC: ColT1; Lab: 'M 1';			fLab: ''; Action: acMrLink;	msEvent: 0; iByte: 0; iMarker: mrT1), 
    (Wnd: @editWndRange; pCol: @ColRange; x:   0; y: 080; bC: 0; fC: ColT2; Lab: 'M 2';			fLab: ''; Action: acMrLink;	msEvent: 0; iByte: 0; iMarker: mrT2), 
    (Wnd: @editWndRange; pCol: @ColRange; x:   0; y: 080; bC: 0; fC: 15; Lab: 'Cur';			fLab: ''; Action: acMrLink;	msEvent: 0; iByte: 0; iMarker: mrCr), 
    (Wnd: @editWndRange; pCol: @ColRange; x:   0; y: 080; bC: 0; fC: ColM1; Lab: 'M A';			fLab: ''; Action: acMrLink;	msEvent: 0; iByte: 0; iMarker: mrM1), 
    (Wnd: @editWndRange; pCol: @ColRange; x:   0; y: 080; bC: 0; fC: ColM2; Lab: 'M B';			fLab: ''; Action: acMrLink;	msEvent: 0; iByte: 0; iMarker: mrM2), 
    (Wnd: @editWndRange; pCol: @ColRange; x:   0; y: 080; bC: 0; fC: 15; Lab: 'End';			fLab: ''; Action: acMrLink;	msEvent: 0; iByte: 0; iMarker: mrLn), 

    (Wnd: @editWndRange; pCol: @ColRange; x: 550; y: 045; bC: 0; fC: 10; Lab: '  ';	fLab: ''; Action: acEditStr;	msEvent: 0; iByte: 2; pTStr: @InFlNm), 

    (Wnd: @editWndRange; pCol: @ColRange; x:   0; y: 150; bC: 0; fC: 15; Lab: 'R 1';			fLab: ''; Action: acMrSel;	msEvent: 0; iByte: 0),
    (Wnd: @editWndRange; pCol: @ColRange; x:   0; y: 150; bC: 0; fC: 15; Lab: 'R 2';			fLab: ''; Action: acMrSel;	msEvent: 0; iByte: 1),
    (Wnd: @editWndRange; pCol: @ColRange; x:   0; y: 150; bC: 0; fC: 15; Lab: 'R 3';			fLab: ''; Action: acMrSel;	msEvent: 0; iByte: 2), 
    (Wnd: @editWndRange; pCol: @ColRange; x:   0; y: 150; bC: 0; fC: 15; Lab: 'R 4';			fLab: ''; Action: acMrSel;	msEvent: 0; iByte: 3), 

    (Wnd: @editWndRange; pCol: @ColRange; x: 200; y: 180; bC: 0; fC: 10; Lab: ' ';	fLab: ''; Action: acEditStr;	msEvent: 0; iByte: 4; pTStr: @ToFlNm), 
    (Wnd: @editWndRange; pCol: @ColRange; x: 525; y: 180; bC: 0; fC:  7; Lab: '';		fLab: ''; Action: acFreeSel;	msEvent: 0; iByte: 0),
    (Wnd: @editWndRange; pCol: @ColRange; x: 200; y: 213; bC: 0; fC:  7; Lab: '';			fLab: ''; Action: acRInfoSel), 
    (Wnd: @editWndRange; pCol: @ColRange; x: 525; y: 213; bC:12; fC:  0; Lab: 'Go !';			fLab: ''; Action: acStart;	msEvent: 0; iByte: 0; pRoute: @blGo),
    (Wnd: @editWndRange; pCol: @ColRange; x: 005; y: 234; bc: 0; fC:  7; Lab:
     '  Go !        ,\,      (      ).'; fLab: ''; Action: acNone),

    //  
    (Wnd: @editWndParam; pCol: @ColParam; x: 290; y: 015; bC: 0; fC: 10; Lab: ' ';		fLab: ''; Action: acEditStr;	msEvent: 0; iByte: 1; pTStr: @BsFlNm), 
    (Wnd: @editWndParam; pCol: @ColParam; x: 059; y: 050; bC: 0; fC: 14; Lab: '  ';		fLab: ''; Action: acXorWord;	msEvent: 0; iByte: 0; pWord: @NewRate), 
    (Wnd: @editWndParam; pCol: @ColParam; x: 163; y: 050; bC: 0; fC: 14; Lab: '';		fLab: ''; Action: acXorWord;	msEvent: 0; iByte: 0; pWord: @NewChanels), 
    (Wnd: @editWndParam; pCol: @ColParam; x: 298; y: 050; bC: 0; fC: 14; Lab: '  ';	fLab: ''; Action: acEditWord;	msEvent: 0; iByte: 0; pWord: @NewFreq), 
    (Wnd: @editWndParam; pCol: @ColParam; x: 481; y: 050; bC: 0; fC: 14; Lab: '';		fLab: ''; Action: acEditFilter;	msEvent: 0; iByte: 0; FilterIndex: @NewFilterIndex), 
    (Wnd: @editWndParam; pCol: @ColParam; x: 173; y: 085; bC: 0; fC: 10; Lab: ' ';	fLab: ''; Action: acEditStr;	msEvent: 0; iByte: 4; pTStr: @ToFlNm), 
    (Wnd: @editWndParam; pCol: @ColParam; x: 466; y: 085; bC: 0; fC:  7; Lab: '';		fLab: ''; Action: acFreeSel;	msEvent: 0; iByte: 1),
    (Wnd: @editWndParam; pCol: @ColParam; x: 173; y: 115; bC: 0; fC:  7; Lab: '';			fLab: ''; Action: acPInfoSel), 
    (Wnd: @editWndParam; pCol: @ColParam; x: 405; y: 115; bC:12; fC:  0; Lab: 'Go: M 1..M B';		fLab: ''; Action: acStart;	msEvent: 0; iByte: 1; pRoute: @blGo), 
    (Wnd: @editWndParam; pCol: @ColParam; x: 540; y: 115; bC:12; fC:  0; Lab: 'Go: ';		fLab: ''; Action: acStart;	msEvent: 0; iByte: 2; pRoute: @blGo), 
    (Wnd: @editWndParam; pCol: @ColParam; x: 005; y: 141; bc: 0; fC:  7; Lab:
     '  Go        M1  MB \   , ,   .'; fLab: ''; Action: acNone),

    // 
    (Wnd: @editWndPlay;  pCol: @ColPlay; x: 005; y: 005; bC: 0; fC: 15; Lab:
	':\' +
	'"p"  -  \' +
	'        \' +
	'"f"  -  M 5  M 2\' +
	'"g"  -  M A  M B\' +
	'"h"  -  M 5  M B\' +
	'"s"  - \' +
	'LAlt - '; fLab: ''; Action: acNone),
    (Wnd: @editWndPlay;  pCol: @ColPlay; x: 288; y: 016; bC: 0; fC: 10; Lab: ' ';		fLab: ''; Action: acEditStr;	msEvent: 0; iByte: 1;  pTStr: @BsFlNm), 
    (Wnd: @editWndPlay;  pCol: @ColPlay; x: 288; y: 050; bC: 0; fC: 14; Lab: '';		fLab: ''; Action: acEditFilter;	msEvent: 0; iByte: 0;  FilterIndex: @ioPlayFL),
    (Wnd: @editWndPlay;  pCol: @ColPlay; x: 005; y: 114; bc: 0; fC:  7; Lab:
     '       \,    .'; fLab: ''; Action: acNone),

    //  
    (Wnd: @editWndLoop;  pCol: @ColLoop; x: 005; y: 005; bC: 0; fC: 15; Lab:
	':\' +
	'"l"  - \' +
	'"s"  - \' +
	'LAlt - '; fLab: ''; Action: acNone),
    (Wnd: @editWndLoop;  pCol: @ColLoop; x: 228; y: 016; bC: 0; fC: 14; Lab: '';		fLab: ''; Action: acEditFilter;	msEvent: 0; iByte: 0;  FilterIndex: @ioLoopFL), 
    (Wnd: @editWndLoop;  pCol: @ColLoop; x: 228; y: 050; bC: 0; fC: 14; Lab: '';			fLab: ''; Action: acEditACL;	msEvent: 0; iByte: 0;  ACL: @ioLoopACL), 
    (Wnd: @editWndLoop;  pCol: @ColLoop; x: 005; y: 074; bc: 0; fC:  7; Lab:
     '      \    .'; fLab: ''; Action: acNone),

    // 
    (Wnd: @editWndRec;   pCol: @ColRec; x: 005; y: 005; bC: 0; fC: 15; Lab:
	':\' +
	'"r"  - \' +
	'"s"  - \' +
	'LAlt - '; fLab: ''; Action: acNone),
    (Wnd: @editWndRec;   pCol: @ColRec; x: 158; y: 016; bC: 0; fC: 14; Lab: '  ';		fLab: ''; Action: acXorWord;	msEvent: 0; iByte: 0;  pWord: @RecRate), 
    (Wnd: @editWndRec;   pCol: @ColRec; x: 261; y: 016; bC: 0; fC: 14; Lab: '';			fLab: ''; Action: acXorWord;	msEvent: 0; iByte: 0;  pWord: @RecChanels), 
    (Wnd: @editWndRec;   pCol: @ColRec; x: 394; y: 016; bC: 0; fC: 14; Lab: '  ';	fLab: ''; Action: acEditWord;	msEvent: 0; iByte: 1;  pWord: @RecFreq), 
    (Wnd: @editWndRec;   pCol: @ColRec; x: 394; y: 055; bC: 0; fC: 14; Lab: '';		fLab: ''; Action: acEditFilter;	msEvent: 0; iByte: 0;  FilterIndex: @ioRecFL), 
    (Wnd: @editWndRec;   pCol: @ColRec; x: 202; y: 055; bC: 0; fC: 14; Lab: '';			fLab: ''; Action: acEditACL;	msEvent: 0; iByte: 0;  ACL: @ioRecACL), 
    (Wnd: @editWndRec;   pCol: @ColRec; x: 137; y: 100; bC: 0; fC: 10; Lab: ' ';	fLab: ''; Action: acEditStr;	msEvent: 0; iByte: 4;  pTStr: @ToFlNm), 
    (Wnd: @editWndRec;   pCol: @ColRec; x: 380; y: 100; bC: 0; fC:  7; Lab: '';			fLab: ''; Action: acFreeSel;	msEvent: 0; iByte: 2),
    (Wnd: @editWndRec;   pCol: @ColRec; x: 005; y: 124; bc: 0; fC:  7; Lab:
     '     ,\   ,     .'; fLab: ''; Action: acNone)
  );


//       
procedure intCalcButtonSize;
const Border = 5;
var i: tItems;
begin
  for i := Low(tItems) to High(tItems) do With Items[i] do if Action <> acNone then begin
    if fLab = '*' then 
      SetMouseArea(msEvent, x, y, bC, fC, Lab)
    else
      SetMouseArea(msEvent, x, y, fC, bC, Lab + fLab);
    DrawButton(msEvent);
  end;
end;


//    ,     
procedure intCalcLabels;
var  
  i			: tItems;
  Info			: String;
  FreeCoef,
  xmMarkers, xmR,
  mb, sc, j		: Longint;
  ResultL1,				//   T1..T2,
  ResultL2,				// M1..M2,
  ResultLen		: Cardinal;	//   


  //  x-  --
  procedure XCalc(const i: tItems; const pos, fulllen: Cardinal; var xm: LongInt; const divid: LongInt);
  const brd = 20;
  begin
    with Items[i] do begin
      if PropPos and (fulllen <> 0) then x := brd + Round( (WndRangeW - brd * 2) * (pos / fulllen) ) else begin
        x := xm;
        inc(xm, WndRangeW div divid);
      end;
    end;
  end;

  //   ,       
  procedure CreateInfo(const s: string; const size, mul1, mul2: Cardinal);
  begin
    if mul2 = 0 then 
      Info := s + ': ' + ValToStrG(Round(size * mul1 / 1024 / 1024))+' '
    else
      Info := s + ': ' + wvvwSec2Str(size / mul2) + ' / ' + ValToStrG(Round(size * mul1 / 1024 / 1024))+' ';
  end;

begin
  xmMarkers := WndRangeW div nMarkers div 2; xmR := WndRangeW div 4 div 2;

  ResultL1 := Ranges[Markers[1]]^ - Ranges[Markers[0]]^;
  ResultL2 := Ranges[Markers[3]]^ - Ranges[Markers[2]]^;
  ResultLen := ResultL1 + wvIlen + ResultL2;

  for i := Low(tItems) to High(tItems) do with Items[i] do begin
    case Action of

      acStart,
      acNone:		fLab := '';

      acEditStr:	fLab := ': ' + pTStr^;

      acXorWord, 
      acEditWord:	fLab := ': ' + ValToStrG(pWord^);

      acEditFilter:	fLab := ': ' + wvFilters[FilterIndex^].Name;

      acEditACL:	fLab := ': ' + ioACLNames[ACL^];

      acRInfoSel:	begin
        case InfoRange of
	  inrFr1: CreateInfo('  (R1-R2)',	ResultL1,  wvRchanels * wvRrate, wvRfreq);
	  inrFr2: CreateInfo('  (R3-R4)',	ResultL2,  wvRchanels * wvRrate, wvRfreq);
	  inrIns: CreateInfo(' ',	wvIlen,    wvRchanels * wvRrate, wvRfreq);
	  inrAll: CreateInfo(' ',		ResultLen, wvRchanels * wvRrate, wvRfreq);
	  inrLnk: begin
	    case Markers[CurMarker] of
	      mrT1: info := 'M 1';
	      mrT2: info := 'M 2';
	      mrM1: info := 'M A';
	      mrM2: info := 'M B';
	      mrZr: info := '';
	      mrCr: info := '';
	      mrLn: info := '';
	    end;
	    info := 'R ' + chr(CurMarker + 49) + ' -> ' + info;
	  end;
	end;
	fLab := Info;
      end;

      acPInfoSel:	begin
        case InfoParam of
	  inpFr1: CreateInfo(' M 1-M B',	wvvwM2-wvvwT1,	NewChanels * NewRate, NewFreq);
	  inpAll: CreateInfo(' ',	wvRlen,		NewChanels * NewRate, NewFreq);
        end;
        fLab := Info;
      end;

      acFreeSel:	begin
        case iByte of
          0: begin FreeCoef := wvRrate * wvRchanels * wvRfreq end;
          1: begin FreeCoef := NewRate * NewChanels * NewFreq end;
          2: begin FreeCoef := RecRate * RecChanels * RecFreq end;
        end;
	if ToFlNm[1] = '/' then Info := ToFlNm else Info := './' + ToFlNm;
	j := Length(Info);
	while (j >= 1) and (Info[j] <> '/') do dec(j);
	SetLength(Info, j);
	Info := Info + #0;
	get_free_space(@(Info[1]), FreeCoef, mb, sc);
        fLab := ': ' + wvvwSec2Str(sc) + ' / ' + ValToStrG(mb)+' ';
      end;

      acSwBool:		if PropPos then fLab := ': ' else fLab := ': ';
      
      acMrLink:		begin
        XCalc(i, Ranges[iMarker]^, wvRlen, xmMarkers, 7);
	fLab := '';
      end;

      acMrSel:		begin
	if CurMarker = iByte then fLab := '*' else fLab := '';
	case iByte of
	  0:		XCalc(i, 0,		    ResultLen, xmR, 4);
	  1:		XCalc(i, ResultL1,	    ResultLen, xmR, 4);
	  2:		XCalc(i, ResultL1 + wvIlen, ResultLen, xmR, 4);
	  3:		XCalc(i, ResultLen,	    ResultLen, xmR, 4);
	end;
      end;
    end;
  end;
  intCalcButtonSize;
end;


//   
procedure intDrawLock;
begin
  if FilesNoLocked then XSetWindowBackground(prDisplay, editIndWnd, editColors[0]) else XSetWindowBackground(prDisplay, editIndWnd, editColors[12]);
  XClearWindow(prDisplay, editIndWnd);
end;


//   
procedure intChangeLock(const Mode: Boolean);
begin
  FilesNoLocked := Mode;
  intDrawLock;
end;


//    editWndRange,     
procedure intDrawWndRange;
var
  GC		: TGC;

  //     - R#j (acMrSel)      
  //    (acMrLink),   -   -
  function DrawLine(const j: tItems): tItems;
  var i: tItems;
  begin
    for i := Low(tItems) to High(tItems) do with Items[i] do
      if Action = acMrLink then if Markers[Items[j].iByte] = iMarker then begin
        XDrawLine(prDisplay, editWndRange, GC, Items[j].x, Items[j].y, x, y);
	DrawLine := i;
      end;
  end;

  //   T1..T2  M1..M2       
  procedure DrawBlock(const a1, a2: tItems);
  var a, b: tItems;
  begin
    if Ranges[Markers[Items[a1].iByte]]^ <> Ranges[Markers[Items[a2].iByte]]^ then begin
      a := DrawLine(a1); b := DrawLine(a2);
      XDrawLine(prDisplay, editWndRange, GC, Items[a1].x, Items[a1].y, Items[a2].x, Items[a2].y);
      XDrawLine(prDisplay, editWndRange, GC, Items[ a].x, Items[ a].y, Items[ b].x, Items[ b].y);
    end;
  end;

begin
  XClearWindow(prDisplay, editWndRange);
  GC := XCreateGC(prDisplay, editWndRange, 0, Nil);

  intDrawLock;

  if wvRlen <> 0 then begin
    XSetForeGround(prDisplay, GC, ColRange[1]);
    XSetLineAttributes(prDisplay, GC, 3, LineSolid, CapNotLast, JoinMiter);
    DrawBlock(btR0, btR1); DrawBlock(btR2, btR3);
    if InFlNm <> '' then begin
      XSetForeGround(prDisplay, GC, ColRange[11]);
      XDrawLine(prDisplay, editWndRange, GC, Items[btR1].x, Items[btR1].y, Items[btR2].x, Items[btR2].y);
    end;
  end;

  XFreeGC(prDisplay, GC);
end;


//   acNone (          ...    :)
procedure intDrawLabels(const cWnd: TWindow);
var i: tItems; GC: TGC;
begin
  GC := XCreateGC(prDisplay, cWnd, 0, Nil);
  AlfSetFont(GC, FontLabel);
  for i := Low(tItems) to High(tItems) do with Items[i] do if (Action = acNone) and (cWnd = Wnd^) then begin
    XSetBackGround(prDisplay, GC, pCol^[bC]);
    XSetForeGround(prDisplay, GC, pCol^[fC]);
    AlfOutTextXYPS(cWnd, GC, x, x, y, Lab);
  end;
  XFreeGC(prDisplay, GC);
end;


//      Word
procedure intEntVal(var d: Word; const h: string);
var r: LongInt;
begin if FilesNoLocked then begin
  intChangeLock(False);
  r := d; if AlfEnterValue(r, h, MouseXroot, MouseYroot) then else d := r and $ffff;
  intChangeLock(True);
end end;


//      AlfTStr
procedure intEntStr(var d: String; const h: string; const iByte: Byte);
begin if FilesNoLocked then begin
  intChangeLock(False);
  if AlfEnterString(d, h, MouseXroot, MouseYroot) then else intTestFiles(iByte);
  intChangeLock(True);
end end;


procedure AddRng(var w: Word; const a: LongInt);
var d: LongInt absolute w;
begin
  if TestMKey(skLShift) then
    if TestMKey(skLCtrl) then inc(d, 10000*a) else inc(d, 100*a)
  else
    if TestMKey(skLCtrl) then inc(d, 1000*a) else inc(d, 10*a);
end;


//  
procedure intFullingTime(var Event: TXEvent; const BlockEn: Boolean);
var
  i		: tItems;
  FNLChanged	: Boolean;

  procedure SwapMarkers(const n1, n2:Byte);
  var tmp:tMarkers;
  begin
    if Ranges[Markers[n1]]^>Ranges[Markers[n2]]^ then begin
      tmp := Markers[n1]; Markers[n1] := Markers[n2]; Markers[n2] := tmp;
    end;
  end;

begin
  OldFullingTime(Event, BlockEn);

  if wvvwWaveWasReBuild then begin
    SwapMarkers(0, 1); SwapMarkers(2, 3);
    intCalcLabels; intDrawWndRange; intDrawLabels(editWndRange);
    wvvwWaveWasReBuild := False;
  end;

  case Event.EventType of

  Expose: with Event.XExpose do if Count = 0 then begin
    if Window = editWndRange then intDrawWndRange;
    intDrawLabels(Window);
  end;

  ButtonPress: begin
    for i := Low(tItems) to High(tItems) do with Items[i] do if Action <> acNone then if MouseInArea(msEvent) then begin
{$ifdef SelfTune}
      if TestMKey(skRShift) then inc(Items[i].x);
      if TestMKey(skLShift) then dec(Items[i].x);
      if TestMKey(skRCtrl) then inc(Items[i].y);
      if TestMKey(skLCtrl) then dec(Items[i].y);
      WriteLn(x:10, y:10);
{$else}
      case Action of
	  acStart:	pRoute(iByte);
	  acEditWord:	begin
	    if TestButton(MouseLmsk) then AddRng(pWord^,  1);
	    if TestButton(MouseRmsk) then AddRng(pWord^, -1);
	    if TestButton(MouseMmsk) then intEntVal(pWord^, Lab + ' - ');
	    if iByte = 1 then begin wvWfreq := pWord^; mixrNewFile; end;
	  end;
	  acXorWord:    pWord^ := pWord^ xor 3;
	  acEditStr:	intEntStr(pTStr^, Lab + ' - ', iByte);
	  acEditFilter:	if FilterIndex^ = High(wvtFilterIndex) then FilterIndex^ := Low(wvtFilterIndex) else inc(FilterIndex^);
	  acEditACL:	if ACL^ = High(iotAutoCtrlLevel) then ACL^ := Low(iotAutoCtrlLevel) else inc(ACL^);
	  acMrLink:	if Markers[CurMarker] <> iMarker then Markers[CurMarker] := iMarker;
	  acMrSel:	if CurMarker <> iByte then CurMarker := iByte;
	  acPInfoSel:	if InfoParam = High(tInfoParam) then InfoParam := Low(tInfoParam) else inc(InfoParam);
	  acRInfoSel:	if InfoRange = High(tInfoRange) then InfoRange := Low(tInfoRange) else inc(InfoRange);
	  acSwBool:	PropPos := not PropPos;
      end;
{$endif}
      if NewFreq = 0 then NewFreq := 1;
      if RecFreq = 0 then RecFreq := 1;
      SwapMarkers(0, 1);
      SwapMarkers(2, 3);

      intCalcLabels;
      Break;
    end;
  end;

  KeyPress: if FilesNoLocked then begin
    FNLChanged := True;
    intChangeLock(False);
    case KeyInResult of
      ord('p'): PlayFile(wvvwPos, wvRlen);
      ord('r'): begin wvWrate := RecRate; wvWchanels := RecChanels; wvWfreq := RecFreq; recfile(ToFlNm); end;
      ord('l'): begin wvWchanels := 2; ShowLevel; end;
      ord('f'): PlayFile(wvvwT1, wvvwT2);
      ord('g'): PlayFile(wvvwM1, wvvwM2);
      ord('h'): PlayFile(wvvwT1, wvvwM2);
      else FNLChanged := False;
    end;
    if FNLChanged then KeyInResult := 0;
    intChangeLock(True); wvvwWaveWasReBuild := FNLChanged;
  end;

  end; // Case
end;


//   
procedure intCreateWindows;
var i: tItems;
begin
  NewRootWindow(WndRangeX, WndRangeY, WndRangeW, WndRangeH, ' ', editWndRange);
  NewRootWindow(WndParamX, WndParamY, WndParamW, WndParamH, ' ', editWndParam);
  NewRootWindow(WndPlayX,  WndPlayY,  WndPlayW,  WndPlayH,  '',	   editWndPlay);
  NewRootWindow(WndLoopX,  WndLoopY,  WndLoopW,  WndLoopH,  ' ',	   editWndLoop);
  NewRootWindow(WndRecX,   WndRecY,   WndRecW,   WndRecH,   '',		   editWndRec);

  SetVGAPalette(editWndRange, ColRange);
  SetVGAPalette(editWndParam, ColParam);
  SetVGAPalette(editWndPlay,  ColPlay);
  SetVGAPalette(editWndLoop,  ColLoop);
  SetVGAPalette(editWndRec,   ColRec);

  for i := Low(tItems) to High(tItems) do With Items[i] do if Action <> acNone then NewMouseArea(Wnd^, msEvent);
  intCalcLabels;
end;


//    INI- 
procedure intExitProc;
begin
  ExitProc := OldExitProc;
  IniOpen('Editor');
  IniPut('Base Name',		BsFlNm);
  IniPut('Insert Name',		InFlNm);
  IniPut('To Name',		ToFlNm);
  IniPut('Recording Freq',	RecFreq);
  IniPut('Recording Rate',	RecRate);
  IniPut('Recording Chan',	RecChanels);
  IniPut('Proportional',	PropPos);
  IniClose;
end;

procedure intReadParam;
var li: Longint;
begin
  IniOpen('Editor');
  if BsFlNm = '' then IniGet('Base Name', BsFlNm);
  IniGet('Insert Name',		InFlNm);
  IniGet('To Name',		ToFlNm);
  if IniGet('Recording Freq', li) then RecFreq := li;
  if IniGet('Recording Rate', li) then RecRate := li;
  if IniGet('Recording Chan', li) then RecChanels := li;
  IniGet('Proportional',	PropPos);

  IniGet('Font Labels', FontLabel);

  IniGet('Window Range X',  WndRangeX);
  IniGet('Window Range Y',  WndRangeY);
  
  IniGet('Window Param X',  WndParamX);
  IniGet('Window Param Y',  WndParamY);

  IniGet('Window Play X',   WndPlayX);
  IniGet('Window Play Y',   WndPlayY);

  IniGet('Window Loop X',   WndLoopX);
  IniGet('Window Loop Y',   WndLoopY);

  IniGet('Window Record X', WndRecX);
  IniGet('Window Record Y', WndRecY);
  IniClose;
end;


begin
  OldFullingTime := FullingTime;	FullingTime := @intFullingTime;
  OldExitProc := ExitProc;		ExitProc := @intExitProc;
  BsFlNm := ParamStr(1);
  intReadParam;
  intCreateWindows;
  intTestFiles(7);
end.
